def intersection_set(S1, S2):
    """ Intersection de deux ensembles

    Parametres:
    ----------
    S1, S2: ensemble (set)

    Retourne:
    --------
    Un ensemble

    Complexité:
    ----------
        O(min(n, k)) avec n:=|S1| et k:=|S2|

    """
    S = set()
    if len(S2) < len(S1):
        S1, S2 = S2, S1

    for a in S1:
        if a in S2:
            S.add(a)
    return S


def intersection_list_set(L):
    """
        Intersection de tous les ensembles dans la listes.

    Parametres:
    -----------
    L:  Liste d'ensembles

    Retourne:
    --------
    Un ensemble

    Complexité:
    ----------
    O(nk) avec n:=|L| et k:=min(|S| pour S in L)

    """
    S = set()
    for e in L:
        S = S.intersection(e)
    return S

def intersection_list_set_rec(L):
    if len(L) == 1:
        return L[0]
    S = L[0]
    return S.intersection(intersection_list_set_rec(L[1:]))

def successeur1(L):
    K = []
    L = sorted(L)
    c = 0
    for i in range(len(L) - 1):
        if L[i] == L[i+1]:
            c += 1
        if L[i] == L[i+1] - 1:
            c += 1
            for j in range(c):
                K.append(L[i])
    return K

def successeur2(L):
    K = []
    for e in L:
        Found = False
        for f in L:
            if e == f - 1 and not Found:
                K.append(e)
                Found = True

    return K

def successeur3(L):
    K = []
    for e in L:
        if e + 1 in L:
            K.append(e)
    return K

def successeur_rec(L):
    if len(L) == 1:
        return []
    K = []
    if L[0] + 1 in L:
        K.append(L[0])
    K = K + successeur_rec(L[1:])
    return K

def element_repetes(L, k):
    d = {}
    for i in L:
        d[i] = d.get(i, 0) + 1

        # if i not in d:
        #   d[i] = 0
        # d[i] += 1
    K = []
    for e, i in d.items():
        if i > k:
            K.append(e)
    return K


def sous_ensemble(S):
    if len(S) == 0:
        return [set()]
    a = S.pop()
    K = sous_ensemble(S)
    T = []
    for Sp in K:
        T.append(Sp)
        T.append(Sp.union([a]))
    return T



def est_carre(u):
    if len(u) % 2 != 0:
        return False
    moitié = len(u)//2
    resultat = True
    for i in range(moitié):
        if u[i] != u[i + moitié]:
            resultat = False
            break
    return resultat

def est_carre_rec(u):
    if len(u) == 0:
        return True
    if len(u) % 2 != 0:
        return False
    moitié = len(u)//2
    resultat = est_carre_rec(u[1:moitié] + u[moitié+1:])
    return resultat and u[0] == u[moitié]


def est_carre_rec2(u):
    if len(u) == 0:
        return True
    if len(u) % 2 != 0:
        return False
    moitié = len(u)//2
    resultat = est_carre_rec(u[0:moitié-1] + u[moitié:-1])
    return resultat and u[moitié] == u[-1]
